<?php
namespace Teknisa\DF\Modules\Relatorios\Factories;

use Doctrine\ORM\EntityManager;

class Dfe16000ConsistenciasAfNfFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getAnaliticoData($params) {
        $sql = "SELECT NF.NRNOTAFISC, NF.CDFILIAL || NF.NRLANCTONF AS CHAVE, LF.NMFILIAL, NF.DTENTRSAID, FONF.NRINSJURFORN
          FROM NOTAFISCAL NF,
            FORNECEDOR FONF,
            (SELECT CDFILIAL,
              NMFILIAL,
              NRORG
            FROM FILIAL
            WHERE ((INSTR(:L_CDFILIRECE, '_' || CDFILIAL || '_') > 0)
            OR (:L_CDFILIRECE                    IS NULL))
            AND NRORG                           = :P_NRORG
            )LF
          WHERE (NF.CDFILIRECE = LF.CDFILIAL)
          AND (NF.NRORG        = LF.NRORG)
          AND (NF.DTENTRSAID BETWEEN TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINAL, 'DD/MM/YYYY'))
          AND (NF.IDENTRSAIDOP = 'E')
          AND (FONF.CDFORNECED = NF.CDFORNECED)
          AND (FONF.NRORG      = NF.NRORG)
          AND (NF.CDFILIAL
            ||NF.NRLANCTONF IN
            (SELECT R.CDFILIAL
              ||R.NRLANCTONF
            FROM NFRELACAF R ,
              NOTAFISCAL N,
              (SELECT CDFILIAL,
                NMFILIAL,
                NRORG
              FROM FILIAL
              WHERE ((INSTR(:L_CDFILIRECE, '_' || CDFILIAL || '_') > 0)
              OR (:L_CDFILIRECE                    IS NULL))
              AND NRORG                           = :P_NRORG
              )LF
            WHERE (N.CDFILIRECE = LF.CDFILIAL)
            AND (N.NRORG        = LF.NRORG)
            AND (N.DTENTRSAID BETWEEN TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINAL, 'DD/MM/YYYY'))
            AND (N.IDENTRSAIDOP = 'E')
            AND (R.NRORG        = N.NRORG)
            AND (R.CDFILIAL     = N.CDFILIAL)
            AND (R.NRLANCTONF   = N.NRLANCTONF)
            ))
          ORDER BY NF.CDFILIAL,
            NF.NRNOTAFISC";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $dataSet = $std->fetchAll();
    }
}